<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'warnDt',
    label: '日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'organcode',
    label: '机构',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelCode',
    label: '模型编号',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelName',
    label: '模型名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelSorc',
    label: '及格分',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'ruleCnum',
    label: '触发客户数',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'warnCnum',
    label: '预警客户数',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'ruleTnum',
    label: '触发流水',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'warnTnum',
    label: '预警流水',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

